<!doctype html>
<title>Tic-tac-toe</title>
<style>
    body { font-family: sans-serif }
    .cell { width: 40px; height: 45px; position: relative; border: solid 2px;
            display: inline-block; font-size: 40px; padding: 5px 0px 0px 10px; margin-left: -2px; margin-top: -2px }
    .xo {   padding: 0px;
            width: 40px; height: 40px;
            background-color: white;
            border: none;
            position: relative; top: -9px;
            left: -5px;
            color: white}
    #board { width: 170px; margin: 1em auto }
    #controls { width: 250px; margin: 1em auto }
</style>
<div id=board>
<form method=post>
<?php
error_reporting(22519);

$cookie = $_COOKIE["ttt_cookie"];

if ($_POST["reset"]) {
    setcookie("ttt_cookie", "", time() - 1000);
    $cookie = null;
    }

if ($cookie) {
    $scores = array();
    foreach (explode("/", $cookie) as $part) {
        $parts = explode(":", $part);
        $scores[$parts[0]] = $parts[1];
        }
    }
else {
    $scores = array("X"=>0, "O"=>0, "T"=>0);
    }

$state = $_POST["state"];
if (!$state || $_POST["new"] || $_POST["reset"])
    $state=".........";

$pair = "OX";

for ($i = 0; $i < 9; $i++) {
    if ($_POST["c" . $i])
        $state[$i] = $pair[unplayed($state)%2];
    }

for ($i = 0; $i < 9; $i++) {
    if ($state[$i] == ".")
        echo "<div class=cell><input class=xo type=submit name=c$i></div>";
    else
        echo "<div class=cell>{$state[$i]}</div>";
}

echo "</div>";
echo "<div id=controls>";

if ($result = check_win($state)) {
    $scores[$result] += 1;
    generate_cookie($scores);
    if ($result == "T")
        new_game("Tie!", $scores);
    else
        new_game("$result Wins!", $scores);
    }
else {
    show_stats($scores);
    }

echo "<input type=hidden name=state value='$state'>";
echo "</div>";    

function generate_cookie($scores)
{
    $r = array();
    foreach ($scores as $which => $score)
        $r[] = "$which:$score";

    setcookie("ttt_cookie", join($r, "/"), time() + 24*60*60);
}

/*
 * Given a nine-character string representing the state of the game...
 *    Return "X" or "O" if either has won
 *    Return "T" if all cells filled but tie
 *    Return false otherwise
 *
 * The string "X...O...X" represents an "X" in the upper left, an "O" in the
 * middle, and an "X" in the lower right.
 */
function check_win($state)
{
    foreach (explode(".", "036.147.258.012.345.678.048.246") as $win) {
        $first = $state[(int)$win[0]];
        $second = $state[(int)$win[1]];
        $third = $state[(int)$win[2]];
        if ($first !== "." && $first == $second && $second == $third) {
            return $first;
        }
    }

    if (unplayed($state) == 0)
        return "T";

    return false;
}

/*
 * Return the number of unplayed cells.  count_chars is overkill for this but fun to use!
 */
function unplayed($state)
{
    $counts = count_chars($state,0);
    $rval = $counts[ord(".")];
    return $rval;
}

function show_stats($scores)
{
?>
<?=$scores["X"]?> wins for X, <?=$scores["O"]?> wins for O, <?=$scores["T"]?> ties<br>
<?php
}

function new_game($label, $scores)
{?>
    <div style=text-align:center>
    <?=$label?><br>
    <?php show_stats($scores); ?>
    <input type=submit name=new value="New Game">
    <input type=submit name=reset value='Reset Scores'>
    </div>
<?php
}
