<?php
echo "<!doctype>
<title>My Blog</title>
<style>
    body { margin: 0px; font-family: sans-serif; background-image: url(tile1.png) }
    .common { padding: 0em; border-radius: .3em}
    .hop:hover { position: relative; bottom: .2em }
    #main { padding: 1em 1em 1em 12em; width: 40em; margin: auto auto; height: auto; position: relative}
    .entry h1 { font-family: cursive; font-size: 1.3em; margin-top: 0px; margin-bottom: 0px }
    .entry { background-color: antiquewhite; margin-right: 5em; }
    .entry_text { padding: .5em; }
    .date  { width: 5em; float:right; background-color: antiquewhite; padding: .3em; }
    .date > div {
        width: 4em;
        float:right;
        text-align: center;
        color: white;
        text-transform: lowercase;
        font-weight: bold;
        background-color: black;
        padding: .3em;
        border-radius: .3em
        }
    .date > div > span { font-size: smaller }
    .title_br { border-right: 1px dashed; border-bottom: 1px dashed; border-bottom-right-radius: .3em; padding: 0px .3em }
    .image { width: 100px; }
    .image_left { margin-right: .5em; clear: left; margin-bottom: .5em }
    .image_right { margin-left: .5em; clear: right; margin-bottom: .5em}
    .image_left img:hover { border: 1em solid gray; border-radius: 1em; width: 450px; position: relative; top: 1em; left: 30px; }
    .image_right img:hover { border: 1em solid gray; border-radius: 1em; width: 450px; position: relative; top: 1em; right: 410px; }
    #posts { position: absolute; top: 1em; left: 1em; width: 10em; background-color: antiquewhite }
    #posts a { display: block; margin: 0.25em; text-align: center; }
    #posts a:link { color: black; text-decoration: none; border-bottom: 1px dotted silver }
    #posts a:visited { color: black; text-decoration: none }
    .top { text-align: right; padding: 0 1em .5em 0 }
    #posts h1 { font-weight: bold; font-size: 1.2em; text-align: center; font-family: sans-serif }
    .filter_x:link, .filter_x:visited {
        border-radius: 3px;
        background-color: black;
        color: white;
        font-size: 60%;
        text-decoration: none;
        xdisplay: inline-block;
        }

    #newform { width: 30em; margin: 1em auto; background-image: none; padding: 1em }
    #newform h1 { text-align: center }
    .tags { padding-left: .5em }
    .tags a:link, .tags a:visited {
        border-radius: 3px;
        background-color: black;
        color: white;
        text-decoration: none;
        padding: 1px 3px;
        }
    
    
</style>";

$blog_file = "blog.txt";

include("load_entries.php");

error_reporting(22519);

$mode = $_GET["mode"];

if (!isset($mode) || $mode == "show")
    show_blog();
elseif ($mode == "new") {
    new_entry_form();
    }
elseif ($mode == "add") {
    add_entry();
    }

function new_entry_form()
{
    $tags = array();
    $entries = load_entries("blog.txt");
    foreach ($entries as $entry) {
        foreach ($entry["tags"] as $tag) {
            if (!in_array($tag, $tags))
                $tags[] = $tag;
            }
        }
    sort($tags);
    
?>
<div id=newform>
<h1>New entry</h1>
<form id=newform action=blog2.php method=get style="vertical-align:top">
<input type=hidden name=mode value=add>
Title: <input type=text name=title size=60 required><br>
Date: <input type=date name=date required><br>
Text: <textarea cols=60 rows=10 name=text required></textarea>
<br>
Tags:
<?php
    foreach ($tags as $tag) {
        echo("<input type=checkbox name=tags[] value='$tag'>$tag</input>\n");
        }
?>
<br>
New tag(s): <input type=text name=newtags size=40> (separate with commas)
<br>
<input type=submit value="Done">
</form>
</div>
<?php
}

function add_entry()
{
$params = $_GET;
/*
var_dump("<pre>",$params,"</pre>");
echo "<pre>";
var_dump($params);
echo "</pre>";
*/
$f = fopen("blog.txt", "a");
fwrite($f, "{$params['title']}\n");
if (isset($params['tags']))
    $tags = $params['tags'];
else
    $tags = array();

if (isset($params['newtags'])) {
    foreach (explode(",", $params['newtags']) as $new) {
        $new = trim($new);
        if ($new && !in_array($new, $tags))
            $tags[] = $new;
        }
    }

if (count($tags) != 0) {
    fwrite($f, "tags: " . implode(",", $tags) . "\n");
    }
    
fwrite($f, "{$params['date']}\n");
fwrite($f, "{$params['text']}\n");
fwrite($f, ".end\n");
show_blog();
}

function show_blog()
{
    echo "<div id=main>\n";
    
    $entries = load_entries("blog.txt");

    if (isset($_GET["filter"])) {
        $filter_tag = $_GET["filter"];
        echo "<h1><span style=vertical-align:top>Posts tagged $filter_tag
            <a style=position:relative;top:7px class=filter_x href=blog2.php>&nbsp;X&nbsp;</a></span></h1>\n";
        }
    
    $entry_num = 1;
    $posts = "";
    foreach ($entries as $entry) {
        if ($filter_tag && !in_array($filter_tag, $entry["tags"]))
            continue;
        #var_dump($entry);
        $title = $entry["title"];
        echo generate_date_div($entry["date"]);
        echo "<div class='entry common'>\n";

        $link = "<a href=#entry_$entry_num>$title</a><br>";
        $posts = $link . $posts;
        
        $title = hop($title);
        echo "<h1 id=entry_$entry_num><span class=title_br>$title</span></h1>\n";
        echo "<div class=entry_text>\n";
        foreach (explode("\n",$entry["text"]) as $line) {
            if ($line == "")
                continue;
            if ($line[0] == ".")
                echo process_dot_line($line);
            else
                echo "$line\n";
            }
        echo "</div>";
        if ($entry["tags"]) {
            echo "<div class=tags>";
            foreach ($entry["tags"] as $tag) {
                echo "<a href='blog2.php?filter=$tag'>$tag</a> ";
                }
            echo "</div>";
            }
            
        echo "<div class=top><a href=#top>top</a></div>\n";
        echo "</div><br>\n";
        $entry_num += 1;
        }
        
    echo "<div id=posts class=common><h1>My Posts<br><small>(most recent first)</small></h1>$posts</div>\n";

    echo "</div>\n";
}
        
function hop($s)
{
    $result = "";
    for ($i = 0; $i < strlen($s); $i++) {
        $result .= "<span class=hop>$s[$i]</span>";
        }

    return $result;
}

function process_dot_line($line)
{
    if ($line == ".p") {
        return "<p>";
    } elseif ($line[2] == " ") { // .X ...
        $rest = substr($line, 3);
        return "<{$line[1]}>$rest</{$line[1]}>\n";
        }
    elseif ($line[3] == " ") {
        if ($line[1] == "r")
            $float = "right";
        else
            $float = "left";
        $src = substr($line, 4);
        return "<span class=image_$float style='display:inline;float:$float;width:100px;height:75px;border:1px solid'><img src=$src class='image'></span>";
        }
}

function generate_date_div($date)
{
    $months = "JanFebMarAprMayJunJulAugSepOctNovDec";

    $month = substr($months, (substr($date, 5, 2)-1)*3, 3);
    $day = ltrim(substr($date, 8, 2), "0");
    $year = substr($date, 0, 4);
    return "<div class='date common'><div>$month $day<br><span>$year<span></div></div>\n";
}
