<?php
/*
 * Read blog entries from file named $fname and return an integer-keyed array
 * of entries where each entry is itself an array with title, date, and text keys.
 *
 * The value of the text key 
 */
function load_entries($fname)
{
    $entries = array();
    $f = fopen($fname, "r");
    if (!$f)
        die("Can't open $blog_file");

    while ($title = fgets($f)) {
        $title = rtrim($title);
        $line = fgets($f);
        $tags = array();
        $text = "";
        if (strpos($line, "tags: ") === 0) {
            $line = rtrim($line);
            foreach(explode(",", substr($line, 6)) as $s)
                $tags[] = trim($s);
            $date = rtrim(fgets($f));
        } else {
            $date = rtrim($line);
        }
        while ($line = fgets($f)) {
            if (rtrim($line) == ".end")
                break;
            $text .= trim($line) . "\n";
            }
            
        $entries[] = array("title" => $title, "date" => $date, "text" => $text, "tags" => $tags);
        }

    fclose($f);

    return $entries;
}


